#include "int16.h"
#include "aspen_devel.h"


extern "C" void
API(i16symv) ( const char uplo, const int n,
	     const scalar_t alpha,
	     const scalar_t * a, const int lda,
	     const scalar_t * x, const int incx,
	     const scalar_t beta,
	     scalar_t * y, const int incy )
{
#if 'i'!='h' || ASPEN_HALF_ENABLED

  if ( n <= 0 ) return;
  if ( incy == 0 ) return;

#if 'i'!='h' && 'i'!='k'
  if ( alpha == makeCONST<scalar_t>(0) ) {
    if ( beta == makeCONST<scalar_t>(1) ) return;
    if ( beta == makeCONST<scalar_t>(0) && incy == 1 ) {
      API(I16ZERO) ( y, n );
    } else {
      API(i16scal) ( n, beta, y, incy );
    }
    return;
  }
#endif

  int upper = (uplo=='U')||(uplo=='u');
  int lower = (uplo=='L')||(uplo=='l');
  if ( upper ) {
    API(I16SYMVu) ( -1, n, a, lda, x, incx, y, incy, alpha, beta );
  } else if ( lower ) {
    API(I16SYMVl) ( -1, n, a, lda, x, incx, y, incy, alpha, beta );
  } else {
    // error
  }

#endif
}

