#if !defined(CURRENT_GPU)
#  include "../tuning/CURRENT_GPU"
#endif
#if !defined(GPU_ARCH)
#  define	GPU_ARCH	CURRENT_GPU
#endif

#include "int16.h"
#include "aspen_devel.h"

#define NUM_THREADS             64


#if !defined(GPU_ARCH)
error !!
#error un-supported architecture
#endif
#if GPU_ARCH == Tesla
error !!
#error un-supported architecture
#endif // Tesla
#if GPU_ARCH == Fermi
error !!
#error un-supported architecture
#endif // Fermi
#if GPU_ARCH == Kepler
error !!
#error un-supported architecture
#endif // Kepler


#  define	USE_LDG		1
#  define	USE_RESTRICT	1
#  define	USE_TEXTURE	0
#  define	USE_SHFL_REDUCE	1

#if 0
#  if __isDD__
#    define	USE_INLINE	0
#  else
#    define	USE_INLINE	1
#  endif
#else
#    define	USE_INLINE	0
#endif

#  define	GY2D		4

#include "aspen_devel_postdef.h"

#define	ASPEN_UPLO		UPPER
#define	SUMUP_PREFIX		I16SYMVU

#include "opt-symv"

#if CURRENT_GPU==GPU_ARCH
#  if !defined(BLOCK_SIZE) || !defined(VX) || !defined(UX)
#    include "../tuning/param-i16symvu.h"
#  endif
#  if defined(BLOCK_SIZE)
#    undef BLOCK_SIZE
#  endif
#  if defined(VX)
#    undef VX
#  endif
#  if defined(UX)
#    undef UX
#  endif
#  include "../template/hesymv_atomic_template.incl"
#endif


extern "C" void
API_private(I16SYMVu_STUB) ( const int blk,
                           const int n, const scalar_t * a, const int lda,
                           const scalar_t * x, const int incx,
                           scalar_t * y, const int incy,
                           const scalar_t alpha, const scalar_t beta )
{

  // y = alpha * A * x + beta * y
  // y(1:n1)
  // x(1:n2)

#if CURRENT_GPU==GPU_ARCH
  if ( n == 0 && blk == -1 ) return;
  int BLK = blk;
# include "../tuning/param-i16symvu.h"
# include "../tuning/i16symv-upper-auto.h"
#else
  fprintf( stderr,
           "Caution, ASPEN is tuned up for %s.\n",
           ASPEN_GPU_Names(CURRENT_GPU) );
#endif

}

