#! /usr/bin/env python
from __future__ import print_function
import sys,os,subprocess
class Bash2Py(object):
  __slots__ = ["val"]
  def __init__(self, value=''):
    self.val = value
  def setValue(self, value=None):
    self.val = value
    return value

def GetVariable(name, local=locals()):
  if name in local:
    return local[name]
  if name in globals():
    return globals()[name]
  return None

def Make(name, local=locals()):
  ret = GetVariable(name, local)
  if ret is None:
    ret = Bash2Py(0)
    globals()[name] = ret
  return ret

def Array(value):
  if isinstance(value, list):
    return value
  if isinstance(value, basestring):
    return value.strip().split(' ')
  return [ value ]

os.environ['LD_LIBRARY_PATH'] = "../../lib:"+str(LD_LIBRARY_PATH.val)
IN=Bash2Py(str(sys.argv[1])+"."+str(sys.argv[2]))
OUT=Bash2Py(str(sys.argv[1])+"."+str(sys.argv[3]))
TOP=Bash2Py(sys.argv[4])




def Make( ) :

    os.chdir("../../src")
    Path("zhemv_upper.cu_o").unlink()
    Path("zhemv_upper.cu_lo").unlink()
    run_command(["make"])
    os.chdir("../bench")
    Path("test-d.o").unlink()
    Path("test2-d.o").unlink()
    run_command(["make", "-j"])
    os.chdir("../tuning/zhemvu-current")


def Main () :
    global PYTHON
    global IN
    global TOP

    run_command([PYTHON, "../anal_symv.py", IN, "4", TOP], stdout="anal_symv-result")
    run_command(["cat","-n",TOP])
    run_command([PYTHON, "../code_gen.py", TOP, "u", "zhemv-upper-auto", "0"])
    outfile="zhemv-upper-auto"+".h"
    shutil.copy(outfile,"../"+outfile)


def DO_PYTHON () :
    global ID
    global OUT
    global PYTHON

    IN_pattern=[]
    with open( 'IN-exe-c', mode = 'r' ) as file :
        line = file.readline()
        lineno = 0
        while line :
            S = line.split()
            if S[0] >= 0 :
                lineno = lineno+1
                if lineno > 2 : 
                    IN_pattern[] = S[0]
            line = file.readline()
    IN_pattern = sorted(IN_pattern, key=lambda x: x[0])

    DATA_pattern=[]
    with open( OUT, mode = 'r' ) as file :
        line = file.readline()
        flag = 0
        lineno = 0
        while line :
            if 'BLK' in line :
                line = re.sub( '.*% BLK', '% BLK', line )
                line = re.sub( '=', ' ', line )
                S = line.split()
                flag = 1 if int(S[3]) == ID else 0
            elif 'N=' in line and flag > 0 :
                if flag == 1 :
                    flag = flag + 1 
                else :
                    S = line.split()
                    DATA_pattern[lineno] = '{} {}\n'.format(S[1],S[4])
                    lineno = lineno + 1
            line = file.readline()
    DATA_pattern = sorted(DATA_pattern, key=lambda x: x[0])

    logfile="log-RANK{}".format(ID)
    with open( logfile, mode = 'w' ) as outfile :
        for i in range(len(DATA_pattern)) :
            logfile.write( '{}\n'.format(DATA_pattern[i]) )


    matfile="cc{}.py".format(ID)
    cat_string_to_file(matfile,
'''import numpy as np
from scipy.sparse import lil_matrix, csr_matrix
from scipy.sparse.linalg import spsolve as linsolve
S=np.array([ 0,
'''
    with open( matfile. mode = 'a' ) as outfile :
        outfile.write('y=np.array([ 0,')
        for i in range(len(IN_pattern)) :
            outfile.write('{},\n')
        outfile.write(']\n')

        for i in range(len(DATA_pattern)) :
            S = DATA_pattern[i],split()
            logfile.write( '{}\n'.format(S[1]))

    append_string_to_file(matfile,
'''
M = min(S.shape[0],y.shape[0])
N = S[M-1]-S[0]+1

z  = [0]*N
ii = list(range(0,N))+[S[0]]*N

norm = np.linalg.norm(y)
if norm > 0:

        EtE = lil_matrix( (N,N) )
        for j in range(0,M):
                k = S[j]-S[0]
                EtE[k,k] = +1.
        EtE = EtE.tocsr()

        D = lil_matrix( (N,N) )
        for j in range(1,N-1):
                D[j,j-1] = +1.
                D[j,j  ] = -2.
                D[j,j+1] = +1.
        D = D.tocsr()
        DtD = (D.transpose()).dot(D)
        del D
        DtD = DtD.tocsr()

        alpha = 1./N
        AA = EtE + alpha * DtD
        del EtE, DtD
        AA = AA.tocsr()

        yy = [0]*N
        for j in range(0,M):
                s = S[j]-S[0]
                yy[s] = y[j]
        del y, S

        yyN = yy[N-1]
        z = linsolve(AA, yy / yyN) * yyN
        z[0] = 0

for j in range(0,N):
        print(ii[j],z[j])
''' )



    if os.fork():
        os.close(_rcw9)
        os.dup2(_rcr9, 0)
        _rcr10, _rcw10 = os.pipe()
        if os.fork():
            os.close(_rcw10)
            os.dup2(_rcr10, 0)
            subprocess.call("awk" + " " + " \\\n\t\tBEGIN { \\\n\t\t\tline = 0; \\\n\t\t} \\\n\t\t{ \\\n\t\t\tline++; \\\n\t\t\tif ( line <= 2 )next; \\\n\t\t\tif ( $1 > 0 ) print $0\",\"; \\\n\t\t} \\\n\t",shell=True,stdout=file("cc"+str(ID.val)+".py",'ab'))
            >> cc$ID.py
        else:
            os.close(_rcr10)
            os.dup2(_rcw10, 1)
            subprocess.call(["awk","{if($1>=0)print}END{print -1}"],shell=True)
            sys.exit(0)
        
    else:
        os.close(_rcr9)
        os.dup2(_rcw9, 1)
        subprocess.call(["sort","-gk","1","IN-exe-c"],shell=True)
        sys.exit(0)
    
    print("])",file=file("cc"+str(ID.val)+".py",'ab'))>> cc$ID.py
    print("y=np.array([ 0,",file=file("cc"+str(ID.val)+".py",'ab'))>> cc$ID.py
    _rc0 = _rcr6, _rcw6 = os.pipe()
    if os.fork():
        os.close(_rcw6)
        os.dup2(_rcr6, 0)
        subprocess.call("sort" + " " + "-gk" + " " + "1",shell=True,stdout=file("log-RANK"+str(ID.val),'wb'))
        > log-RANK$ID
    else:
        os.close(_rcr6)
        os.dup2(_rcw6, 1)
        subprocess.call(["awk"," \\\n\t\t/BLK/{ \\\n\t\t\tgsub(/.*% BLK/,\"% BLK\"); \\\n\t\t\tgsub(/=/,\" \"); \\\n\t\t\tflag = ($4=="+str(ID.val)+")?1:0; next; \\\n\t\t} \\\n\t\t/N=/{ \\\n\t\t\tif(flag>0){ \\\n\t\t\t\tif(flag==1) { \\\n\t\t\t\t\tflag++; next; \\\n\t\t\t\t} \\\n\t\t\t\tprint $2\" \"$5; flag++; \\\n\t\t\t} \\\n\t\t} \\\n\t\t",str(OUT.val)],shell=True)
        sys.exit(0)
    
    _rc0 = subprocess.call("awk" + " " + " \\\n\t\t{\n\t\t\tprint $2\",\";\n\t\t} \\\n\t\t" + " " + "log-RANK"+str(ID.val),shell=True,stdout=file("cc"+str(ID.val)+".py",'ab'))
    >> cc$ID.py
    print("])",file=file("cc"+str(ID.val)+".py",'ab'))>> cc$ID.py
    _rc0 = subprocess.Popen("cat",shell=True,stdin=subprocess.PIPE,stdout=file("cc"+str(ID.val)+".py",'ab'))
    _rc0.communicate("\nM = min(S.shape[0],y.shape[0])\nN = S[M-1]-S[0]+1\n\nz  = [0]*N\nii = list(range(0,N))+[S[0]]*N\n\nnorm = np.linalg.norm(y)\nif norm > 0:\n\n	EtE = lil_matrix( (N,N) )\n	for j in range(0,M):\n		k = S[j]-S[0]\n		EtE[k,k] = +1.\n	EtE = EtE.tocsr()\n\n	D = lil_matrix( (N,N) )\n	for j in range(1,N-1):\n		D[j,j-1] = +1.\n		D[j,j  ] = -2.\n		D[j,j+1] = +1.\n	D = D.tocsr()\n	DtD = (D.transpose()).dot(D)\n	del D\n	DtD = DtD.tocsr()\n\n	alpha = 1./N\n	AA = EtE + alpha * DtD\n	del EtE, DtD\n	AA = AA.tocsr()\n	\n	yy = [0]*N\n	for j in range(0,M):\n		s = S[j]-S[0]\n		yy[s] = y[j]\n	del y, S\n\n	yyN = yy[N-1]\n	z = linsolve(AA, yy / yyN) * yyN\n	z[0] = 0\n\nfor j in range(0,N):\n	print(ii[j],z[j])\n\n")
    _rc0 = _rc0.wait()print '''
    
    M = min(S.shape[0],y.shape[0])
    N = S[M-1]-S[0]+1
    
    z  = [0]*N
    ii = list(range(0,N))+[S[0]]*N
    
    norm = np.linalg.norm(y)
    if norm > 0:
    
    	EtE = lil_matrix( (N,N) )
    	for j in range(0,M):
    		k = S[j]-S[0]
    		EtE[k,k] = +1.
    	EtE = EtE.tocsr()
    
    	D = lil_matrix( (N,N) )
    	for j in range(1,N-1):
    		D[j,j-1] = +1.
    		D[j,j  ] = -2.
    		D[j,j+1] = +1.
    	D = D.tocsr()
    	DtD = (D.transpose()).dot(D)
    	del D
    	DtD = DtD.tocsr()
    
    	alpha = 1./N
    	AA = EtE + alpha * DtD
    	del EtE, DtD
    	AA = AA.tocsr()
    	
    	yy = [0]*N
    	for j in range(0,M):
    		s = S[j]-S[0]
    		yy[s] = y[j]
    	del y, S
    
    	yyN = yy[N-1]
    	z = linsolve(AA, yy / yyN) * yyN
    	z[0] = 0
    
    for j in range(0,N):
    	print(ii[j],z[j])
    
'''>> cc$ID.py
    _rc0 = subprocess.call([str(PYTHON.val),"cc"+str(ID.val)+".py"],shell=True)

def DO_MATLAB () :
    global ID
    global OUT

    print("S=[ 0",file=file("cc"+str(ID.val)+".m",'wb'))> cc$ID.m
    _rc0 = subprocess.call("awk" + " " + " \\\n\t\tBEGIN { \\\n\t\t\tline = 0; \\\n\t\t} \\\n\t\t{ \\\n\t\t\tline++; \\\n\t\t\tif ( line <= 2 )next; \\\n\t\t\tif ( $1 > 0 ) print; \\\n\t\t} \\\n\t" + " " + "IN-exe-c",shell=True,stdout=file("cc"+str(ID.val)+".m",'ab'))
    >> cc$ID.m
    _rc0 = subprocess.Popen("cat",shell=True,stdin=subprocess.PIPE,stdout=file("cc"+str(ID.val)+".m",'ab'))
    _rc0.communicate("];\n\ny=[ 0\n")
    _rc0 = _rc0.wait()print '''
    ];
    
    y=[ 0
'''>> cc$ID.m
    _rc0 = subprocess.call("awk" + " " + " \\\n\t\t/BLK/{ \\\n\t\t\tgsub(/=/,\" \"); \\\n\t\t\tflag = ($4=="+str(ID.val)+")?1:0; next; \\\n\t\t} \\\n\t\t/N=/{ \\\n\t\t\tif(flag>0){ \\\n\t\t\t\tif(flag==1) { \\\n\t\t\t\t\tflag++; next; \\\n\t\t\t\t} \\\n\t\t\t\tprint $2\" \"$5; flag++; \\\n\t\t\t} \\\n\t\t} \\\n\t\t" + " " + str(OUT.val),shell=True,stdout=file("log-RANK"+str(ID.val),'wb'))
    > log-RANK$ID
    _rc0 = subprocess.call("awk" + " " + " \\\n\t\t{\n\t\t\tprint $2;\n\t\t} \\\n\t\t" + " " + "log-RANK"+str(ID.val),shell=True,stdout=file("cc"+str(ID.val)+".m",'ab'))
    >> cc$ID.m
    _rc0 = subprocess.Popen("cat",shell=True,stdin=subprocess.PIPE,stdout=file("cc"+str(ID.val)+".m",'ab'))
    _rc0.communicate("];\n\n[M,c]=size(S);\n[MM,c]=size(y);\nif MM<M\n	M=MM\nend\nN=S(M)-S(1)+1;\n\nz=zeros(N,1);\nii=zeros(N,1);\nfor j=1:N\n	ii(j) = j+S(1)-1;\nend\n\nnorm = y'*y;\nif norm > 0\n\n	EtE = sparse(N,N);\n	for j=1:M\n		k=S(j)-S(1)+1;\n		EtE(k,k)=1;\n	end\n\n	D = sparse(N,N);\n	for j=2:N-1\n		D(j,j-1)=1; D(j,j)=-2; D(j,j+1)=1;\n	end\n	DtD=D'*D/N;\n\n	AA=EtE+DtD;\n\n	yy=zeros(N,1);\n	for j=1:M\n		s = S(j)-S(1)+1;\n		yy(s) = y(j);\n	end\n\n	yyN=yy(N);\n	yy=yy/yyN;\n	z=(AA\\yy)*yyN;\n\nend\n\n[ii,z]\n")
    _rc0 = _rc0.wait()print '''
    ];
    
    [M,c]=size(S);
    [MM,c]=size(y);
    if MM<M
    	M=MM
    end
    N=S(M)-S(1)+1;
    
    z=zeros(N,1);
    ii=zeros(N,1);
    for j=1:N
    	ii(j) = j+S(1)-1;
    end
    
    norm = y'*y;
    if norm > 0
    
    	EtE = sparse(N,N);
    	for j=1:M
    		k=S(j)-S(1)+1;
    		EtE(k,k)=1;
    	end
    
    	D = sparse(N,N);
    	for j=2:N-1
    		D(j,j-1)=1; D(j,j)=-2; D(j,j+1)=1;
    	end
    	DtD=D'*D/N;
    
    	AA=EtE+DtD;
    
    	yy=zeros(N,1);
    	for j=1:M
    		s = S(j)-S(1)+1;
    		yy(s) = y(j);
    	end
    
    	yyN=yy(N);
    	yy=yy/yyN;
    	z=(AA\yy)*yyN;
    
    end
    
    [ii,z]
'''>> cc$ID.m
    _rc0 = subprocess.call(["octave","cc"+str(ID.val)+".m"],shell=True)

Main()
_rc0 = subprocess.call(["\rm","zhemv-upper-auto2.h"],shell=True)
_rc0 = subprocess.call(["touch","zhemv-upper-auto2.h"],shell=True)
_rc0 = subprocess.call("awk" + " " + " \\\n\tBEGIN{ \\\n\t\tprint \"#if defined(PRESERVE_DROP)\"; \\\n\t\tprint \"#undef  PRESERVE_DROP\"; \\\n\t\tprint \"#endif\"; \\\n\t\tprint \"#define PRESERVE_DROP   1\"; \\\n\t\tprint \"\"; \\\n\t\tfor(i=0;i<=20;i++) print \"#define\\tKERNEL_\"i\"\\t1\"; \\\n\t\texit; \\\n\t} \\\n\t",shell=True,stdout=file("zhemv-upper-auto2.h",'wb'))
> zhemv-upper-auto2.h
_rc0 = subprocess.call(["cp","zhemv-upper-auto2.h","../"],shell=True)
Make()os.dup2(2, 1)

ID_max=Bash2Py(6)
if ("x"+str(ASPEN_TUNING_LEVEL.val) == "xROUGH" ):
    Make("ID_max").setValue(3)
if ("x"+str(ASPEN_TUNING_LEVEL.val) == "xFULL" ):
    Make("ID_max").setValue(10)
ID_list=Bash2Py(" 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 ")
_rc0 = subprocess.call("awk" + " " + "BEGIN{i=0}{if($1>1)N[i++]=$1}END{NN=i;for(k=0;k<NN;k++){i=int(rand()*NN);j=int(rand()*NN); t=N[i];N[i]=N[j];N[j]=t;} print 1; print 0; for(i=0;i<NN;i++)print N[i]; print -1}" + " " + "IN-exe-c",shell=True,stdout=file("IN-exe-C",'wb'))
> IN-exe-C
_rc0 = subprocess.call(["\rm",str(OUT.val)],shell=True)
_rc0 = subprocess.call(["touch",str(OUT.val)],shell=True)
for Make("ID").val in Array(ID_list.val):
    if (int(ID.val) <= int(ID_max.val) ):
        Make("POINT").setValue(os.popen("awk \"BEGIN{ X=0; }{ if (NR==\""+str(ID.val)+"\" && $1"+os.path.expanduser("~+"/)+"[0-9]/) { X=$1; exit; } }END{ gsub(/[0-9]*::/,"",X); print X; }\" "+str(TOP.val)).read().rstrip("\n"))
        if (int(ID.val) == 0 -o str(POINT.val) -gt "10000" ):
            _rcr2, _rcw2 = os.pipe()
            if os.fork():
                os.close(_rcw2)
                os.dup2(_rcr2, 0)
                subprocess.call(["tee","-a",str(OUT.val)],shell=True)
            else:
                os.close(_rcr2)
                os.dup2(_rcw2, 1)
                subprocess.call(["timeout","-s","KILL","3600","../../bench/test2-zhemv-u","IN-exe-C",str(ID.val)],shell=True)
                sys.exit(0)
        
        else:
            print("% BLK specified="+str(ID.val),file=file(str(OUT.val),'ab'))>> $OUT
            subprocess.call("awk" + " " + "{ if(i==0){i=1;next;} N=$1; if(N>0)print \"N= \"N\" 100 [s] 0 GFLOPS 0 0\"; }" + " " + "IN-exe-C",shell=True,stdout=file(str(OUT.val),'ab'))
            >> $OUT
for Make("ID").val in Array(ID_list.val):
    subprocess.call(["touch","mat_mat."+str(ID.val)],shell=True)
    subprocess.call(["\rm","mat_mat."+str(ID.val)],shell=True)
    print("Fitting the Kernel."+str(ID.val))
    if (1 == 1 ):
        DO_PYTHON()> mat_mat.$ID2> /dev/null
        subprocess.call("awk" + " " + " \\\n\t\t/[0-9]/ { \\\n\t\t\tgsub(/[\\(\\),]/,\"\"); printf(\"%6d %f\\n\", $1, $2); \\\n\t\t} \\\n\t" + " " + "mat_mat."+str(ID.val),shell=True,stdout=file("mat."+str(ID.val),'wb'))
        > mat.$ID
    else:
        DO_MATLAB()> mat_mat.$ID2> /dev/null
        subprocess.call("awk" + " " + " \\\n\t\tBEGIN { \\\n\t\t\tflga=0; \\\n\t\t} \\\n\t\t/ans/ { \\\n\t\t\tflag=1; next; \\\n\t\t} \\\n\t\t/[0-9]/ { \\\n\t\t\tif ( flag ) printf(\"%6d %f\\n\", $1, $2); \\\n\t\t} \\\n\t" + " " + "mat_mat."+str(ID.val),shell=True,stdout=file("mat."+str(ID.val),'wb'))
        > mat.$ID
